// ###########################################################################
// File: EBaseClass.cpp
// (c)Copyright 10/1998, Baptiste Lepilleur (Aka Elyon from Zuul Design)
// ###########################################################################

#include "usuel.hpp"
#include "EBaseClass.h"
#include "EClassId.h"

void 
EBaseClass::prepareObjectContext( EObjectContext &ctx ) const
{
  ctx.setVersion( objectId().version() );
  ctx.setClass( objectId() );
}


EDataStream &
EBaseClass::saveObject( EDataStream &s ) const
{
  EObjectContext ctx( objectId().version(),
                      objectId() );

  s  <<  ctx;
  return saveObjectData( s, ctx );
}


EDataStream &
EBaseClass::loadObject( EDataStream &s,
                        EBaseClass **pObject )
{
  EObjectContext ctx;
  *pObject = NULL;
  s >> ctx;
  *pObject = ctx.clsid().createObject();
  return (*pObject)->loadObjectData( s, ctx );
}


EDataStream &
EBaseClass::saveObjectData( EDataStream &s,
                          const EObjectContext &ctx ) const
{
  EASSERT( false );         // should override this method
  return s;
}


EDataStream &
EBaseClass::loadObjectData( EDataStream &s,
                          const EObjectContext &ctx )
{
  EASSERT( false );         // should override this method
  return s;
}
