// EHashBiT.h: interface for the EHashBiT class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EHASHBIT_H__BF9A2C71_750D_11D3_BE99_0040053AD648__INCLUDED_)
#define AFX_EHASHBIT_H__BF9A2C71_750D_11D3_BE99_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "EHashAssoCleanerT.h"
#include "EHashKeyProviderT.h"
#include "EStringKeyProviderT.h"


#include "EHashBiBaseT.h"

// Constantes:
// #####################Last change: 27/03/98 21h49mn#########################


// Macros:
// #####################Last change: 27/03/98 21h49mn#########################


// Types:
// #####################Last change: 27/03/98 21h49mn#########################

template<class Key, class Item, class KeyArg, class ItemArg, 
         class ItemKeyProvider=EHashKeyProviderCastT<ItemArg>, 
         class KeyProvider=EHashKeyProviderCastT<KeyArg>, 
         class Cleaner =EHashAssoCleanerT<Key, Item> >
class EHashBiT : public EHashBiBaseT<Key,Item,KeyArg,ItemArg>
{
public:
  typedef ItemKeyProvider ThisItemKeyProvider;
  typedef KeyProvider ThisKeyProvider;
  typedef EHashBiT<Key,Item,KeyArg,ItemArg,
                   ItemKeyProvider,
                   KeyProvider,
                   Cleaner> ThisHash;

  /*! Constructor.
   * @param nSize initial size of the table.
   */
  EHashBiT( SL nSize = 3 );

  /*! Destructor
   */
  virtual ~EHashBiT() {}

protected:
  virtual UL doGetKey( KeyArg key ) const;
  virtual UL doGetKeyItem( ItemArg item ) const;
  virtual bool doCompareKey( KeyArg key1, KeyArg key2 ) const;
  virtual bool doCompareItem( ItemArg item1, ItemArg item2 ) const;
  virtual void doFreeAsso( Key &key, Item &item );

private:
  KeyProvider _keyProvider;
  ItemKeyProvider _itemKeyProvider;
  Cleaner _cleaner;
};


// Template Implementation:
// #####################Last change: 27/03/98 21h49mn#########################


template<class Key, class Item, class KeyArg, class ItemArg, class ItemKeyProvider, class KeyProvider, class Cleaner >
inline 
EHashBiT<Key,Item,KeyArg,ItemArg,ItemKeyProvider,KeyProvider,Cleaner>::EHashBiT( SL nSize ) :
    EHashBiBaseT<Key,Item,KeyArg,ItemArg>( nSize )
{
}


template<class Key, class Item, class KeyArg, class ItemArg, class ItemKeyProvider, class KeyProvider, class Cleaner >
inline UL 
EHashBiT<Key,Item,KeyArg,ItemArg,ItemKeyProvider,KeyProvider,Cleaner>::doGetKey( KeyArg key ) const
{
  return _keyProvider.getKey( key );
}


template<class Key, class Item, class KeyArg, class ItemArg, class ItemKeyProvider, class KeyProvider, class Cleaner >
inline bool 
EHashBiT<Key,Item,KeyArg,ItemArg,ItemKeyProvider,KeyProvider,Cleaner>::doCompareKey( KeyArg key1, KeyArg key2 ) const
{
  return _keyProvider.compareKey( key1, key2 );
}


template<class Key, class Item, class KeyArg, class ItemArg, class ItemKeyProvider, class KeyProvider, class Cleaner >
inline UL 
EHashBiT<Key,Item,KeyArg,ItemArg,ItemKeyProvider,KeyProvider,Cleaner>::doGetKeyItem( ItemArg item ) const
{
  return _itemKeyProvider.getKey( item );
}


template<class Key, class Item, class KeyArg, class ItemArg, class ItemKeyProvider, class KeyProvider, class Cleaner >
inline bool 
EHashBiT<Key,Item,KeyArg,ItemArg,ItemKeyProvider,KeyProvider,Cleaner>::doCompareItem( ItemArg item1, 
                                                                      ItemArg item2 ) const
{
  return _itemKeyProvider.compareKey( item1, item2 );
}


template<class Key, class Item, class KeyArg, class ItemArg, class ItemKeyProvider, class KeyProvider, class Cleaner >
inline void 
EHashBiT<Key,Item,KeyArg,ItemArg,ItemKeyProvider,KeyProvider,Cleaner>::doFreeAsso( Key &key, Item &item )
{
  _cleaner.freeAsso( key, item );
}


#endif // !defined(AFX_EHASHBIT_H__BF9A2C71_750D_11D3_BE99_0040053AD648__INCLUDED_)
