// ###########################################################################
// File: EToolLibCompilerSettings.h
// (c)Copyright 03/1999, Gaia Creation, Baptiste Lepilleur
// ###########################################################################

#if !defined(AFX_ETOOLLIBCOMPILERSETTINGS_H__B78AA254_D476_11D2_BD55_0040053AD648__INCLUDED_)
#define AFX_ETOOLLIBCOMPILERSETTINGS_H__B78AA254_D476_11D2_BD55_0040053AD648__INCLUDED_

// Compiler supports template friend class.
#ifndef _MSC_VER
#define _SUPPORT_TEMPLATE_FRIEND
#endif

// Assert macro
#ifdef _MFC_VER         // Visual C++
# define ETL_ASSERT(expr) ASSERT(expr)
#endif


#ifdef _MSC_VER
#  define ETOOL_HASMUTABLE
#endif


#ifdef ETOOL_HASMUTABLE
#  define EMUTABLE mutable
#  define EMUTABLE_DO(Type) this
#else  // ETOOL_HASMUTABLE
#  define EMUTABLE
#  define EMUTABLE_DO(Type) ((Type *)this)
#endif // ETOOL_HASMUTABLE



// The following define is used by ECallback family templates.
// Setting the maximum length of a pointer on a member function
// If you are using a compiler which is not defined, you can always try setting the
// macro to a value and compile in debug mode.
// An assertion check that the effective size of a pointer is ok !
#ifdef _MSC_VER         // Visual C++
# define _ETOOLLIB_MAX_PTR_MEMBER_FUNCTION_SIZE 16

#elif defined __BORLANDC__      // C++ Builder
# define _ETOOLLIB_MAX_PTR_MEMBER_FUNCTION_SIZE 12

//#elif defined  __GNUC__         // Gnu C++ 
//# error "egcs is not yet supported. It will be."

#else 
# error "Unkown pointer on member function maximum size."
# define _ETOOLLIB_MAX_PTR_MEMBER_FUNCTION_SIZE 24

#endif


// ###########################################################################
// Pragmas...
// ###########################################################################

#ifdef __WATCOMC__
#pragma off (unreferenced)
#pragma warning 391 9   // warn off assigment found in boolean expression
#pragma warning 389 9   // warn off integrated value may be truncated
#pragma warning 379 9   // warn off delete expression will invoke a non virtual destructor
#pragma warning 665 9   // warn off tempory object use to initialise non constant reference.
#pragma warning 604 9   // warn off must look ahead...
#pragma warning 367 9   // warn off always true
#pragma warning 368 9   // warn off always false
#pragma warning 13 9   // warn off unreachable
#endif

#ifdef _MSC_VER     // Visual C++
# pragma warning( disable: 4786 )
#endif




#endif // !defined(AFX_ETOOLLIBCOMPILERSETTINGS_H__B78AA254_D476_11D2_BD55_0040053AD648__INCLUDED_)
