// TfwkClassId.cpp: implementation of the TfwkClassId class.
//
//////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <string.h>
#include "TfwkClassId.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


//TfwkClassId * TfwkClassId::_pClassIdFirst =NULL;

__declspec(thread) static TfwkClassId * _pClassIdFirst =NULL;


    
TfwkClassId *
TfwkClassId::firstClassId()
{
  return _pClassIdFirst;
}


TfwkClassId *
TfwkClassId::findClassId( const char *szNameClass )
{
  TfwkClassId *pClassId = firstClassId();

  if ( !szNameClass )
    return NULL;

  for ( ; pClassId; pClassId = pClassId->nextClassId() )
  {
    if ( !strcmp( szNameClass, pClassId->nameClass() ) )   // found !
      return pClassId;
  }

  return NULL;    // not found !
}


TfwkClassId *
TfwkClassId::findInheritedClassId( const char *szNameParentClass,
                                   TfwkClassId *pClassIdPrev )
{
  if ( !pClassIdPrev )
    pClassIdPrev = firstClassId();    // start a new search 
  else
    pClassIdPrev = pClassIdPrev->nextClassId();

  if ( !szNameParentClass ) 
    szNameParentClass = "";

  for ( ; pClassIdPrev; pClassIdPrev = pClassIdPrev->nextClassId() )
  {
    if ( !strcmp( szNameParentClass, pClassIdPrev->nameParentClass() ) )
      return pClassIdPrev;      // found
  }

  return NULL;    // not found
}
