// TfwkDlg.h : header file
//

#if !defined(AFX_TFWKDLG_H__1D7D9206_4132_11D3_BE28_0040053AD648__INCLUDED_)
#define AFX_TFWKDLG_H__1D7D9206_4132_11D3_BE28_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Resource.h"
#include "TfwkUiTreeViewSuite.h"
#include "TfwkUiTestSuiteReport.h"
class TfwkUiCfg;

/////////////////////////////////////////////////////////////////////////////
// TfwkDlg dialog

class TfwkDlgCloseListener
{
public:
  virtual void windowClosed() =0;
};


class TfwkDlg : public CDialog
{
// Construction
public:
	TfwkDlg(CWnd* pParent = NULL);	// standard constructor
  ~TfwkDlg();

  /*!
   * Adds a listener.
   * The listener receive a message when the window is closed.
   * @param pTfwkDlgCloseListener Pointer on the listener to add.
   */
  void addWindowCloseListener( TfwkDlgCloseListener *pListener );

  /*! Create the modeless dialog.
   * @return \c TRUE on success. \c FALSE if failed.
   */
  BOOL Create();
  
  
  void ReportError( const TfwkUiReportError &err );

  void runAllTest();

  void runSuite( const CString &strName );

// Dialog Data
	//{{AFX_DATA(TfwkDlg)
	enum { IDD = IDD_TESTFRAMEWORK_DIALOG };
	CListCtrl	_lvResult;
	TfwkUiTreeViewSuite	_treeSuite;
	CListBox	_lbUnitTest;
	CString	_strFailure;
	CString	_strError;
	CString	_strSuccess;
	CString	_strTotal;
	CString	_strSkipped;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TfwkDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(TfwkDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTfwkuiNew();
	afx_msg void OnTfwkuiOpen();
	afx_msg void OnTfwkuiSave();
	afx_msg void OnTfwkuiQuit();
	afx_msg void OnTfwkuiAbout();
	afx_msg void OnTfwkuiHelp();
  afx_msg void OnTfwkuiTreeSuiteNewSuite();
  afx_msg void OnTfwkuiTreeSuiteDeleteSuite();
  afx_msg void OnTfwkuiTreeSuiteAddTest();
  afx_msg void OnTfwkuiTreeSuiteRemoveTest();
  afx_msg void OnTfwkuiTreeSuiteEditSuite();
  afx_msg void OnTfwkuiTreeSuiteRunSuite();
	afx_msg void OnUpdateTfwkuiUnittestShowOnlyUnused(CCmdUI* pCmdUI);
	afx_msg void OnTfwkuiUnittestShowOnlyUnused();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP();

private:
  CString getLastSavedFilename();
  void loadTestSuite( const CString &strFilename,
                      bool bSilentError = false );
private:
  enum
  {
    imgAssertion =0,
    imgException,
  };

  bool IsChanged() const;
  void SetChange( bool bChanged = true );
  void GetTestList();
  void UpdateUi();
  void UpdateListUnitTest();
  void LogReportTestSuite();
  void SetupReportList();
  void StartLogReportTestSuite();

  TfwkUiCfg &cfg();

  HACCEL m_hAccelerator;
  CImageList _imlReport;
  TfwkUiCfg *_pConfig;
  bool _bChanged;
  TfwkUiTestSuiteReport _reportTestSuite;

  typedef TfwkArrayT<TfwkDlgCloseListener *> ListenerArray;
  ListenerArray _apListener;

  /*! Parents Window. May be \c NULL.
   */
  CWnd *_pParentWnd;
};


inline TfwkUiCfg &
TfwkDlg::cfg()
{
  ASSERT( _pConfig );
  return *_pConfig;
}


inline bool 
TfwkDlg::IsChanged() const
{
  return _bChanged;
}


inline void 
TfwkDlg::SetChange( bool bChanged )
{
  _bChanged = bChanged;
}


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TFWKDLG_H__1D7D9206_4132_11D3_BE28_0040053AD648__INCLUDED_)
