// TfwkInterfaceInDll.h: interface for the TfwkInterfaceInDll class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFWKINTERFACEINDLL_H__3FE85121_46B4_11D3_BE39_0040053AD648__INCLUDED_)
#define AFX_TFWKINTERFACEINDLL_H__3FE85121_46B4_11D3_BE39_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TfwkInterfaceIn.h"
class TfwkUnitTest;

/*! \class TfwkInterfaceIn
 * \include "TfwkInterfaceIn.h"
 * \brief This class implements the interface use to receive message from the UI.
 */
class TFWK_UI_EXPORT TfwkInterfaceInDll : public TfwkInterfaceIn  
{
public:
	TfwkInterfaceInDll();
	virtual ~TfwkInterfaceInDll();

  /*!
   * Runs a test on a test method.
   *
   * @param info [In] Information about the method used for the test.
   * @param report [In/Out] Report about the test.
   */
  virtual void doTest( const TfwkUnitTestMethodInfo &info,
                       TfwkTestReport &report );


  /*!
   * Called by doTest() just before the test is run.
   *
   * @param info [In] Information about the method used for the test.
   * @param report [Out] Report about the test.
   * @param test [In] Reference on the unit test object with is about to be used.
   */
  virtual void preRunTest( const TfwkUnitTestMethodInfo &info,
                           TfwkTestReport &report,
                           const TfwkUnitTest &test ) {}

  /*!
   * Called by doTest() after the test has been run.
   *
   * This method is called even if the test failed.
   *
   * @param info [In] Information about the method used for the test.
   * @param report [Out] Report about the test.
   * @param test [In] Reference on the unit test object with is about to be used.
   */
  virtual void postRunTest( const TfwkUnitTestMethodInfo &info,
                            TfwkTestReport &report,
                            const TfwkUnitTest &test ) {}

  /*!
   * Called by doRunTest() to run the test.
   *
   * This method is called even if the test failed.
   *
   * @param info [In] Information about the method used for the test.
   * @param report [Out] Report about the test.
   * @param test [In] Reference on the unit test object with is about to be used.
   */
  virtual void doRunTest( const TfwkUnitTestMethodInfo &info,
                          TfwkTestReport &report,
                          TfwkUnitTest &test );

};

#endif // !defined(AFX_TFWKINTERFACEINDLL_H__3FE85121_46B4_11D3_BE39_0040053AD648__INCLUDED_)
