// TfwkUi.cpp: implementation of the TfwkUi class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TfwkUi.h"
#include "TfwkDlg.h"


__declspec(thread) static TfwkDlg *_pdlgTfwkUi =NULL;



class TfwkDlgCloseListenerCleanPointer : public TfwkDlgCloseListener
{
public:
  virtual void windowClosed();
};


void 
TfwkDlgCloseListenerCleanPointer::windowClosed()
{
  _pdlgTfwkUi = NULL;
}


static TfwkDlgCloseListenerCleanPointer closeListener;



void 
tfwkUiShow()
{
#ifdef TFWK_UI_DLL
  AFX_MANAGE_STATE( AfxGetStaticModuleState() );
#endif 
  if ( !_pdlgTfwkUi  ||  !_pdlgTfwkUi->GetSafeHwnd() )
  {
    if ( _pdlgTfwkUi )    // Dialog has been closed...
      delete _pdlgTfwkUi;
    _pdlgTfwkUi = new TfwkDlg();
    _pdlgTfwkUi->addWindowCloseListener( &closeListener );
    VERIFY( _pdlgTfwkUi->Create() );
  }

  if ( _pdlgTfwkUi )
    _pdlgTfwkUi->ShowWindow( SW_SHOW );
}


void 
tfwkUiQuit()
{
#ifdef TFWK_UI_DLL
  AFX_MANAGE_STATE( AfxGetStaticModuleState() );
#endif 
  if ( _pdlgTfwkUi )
  {
    if ( _pdlgTfwkUi->GetSafeHwnd() )    // The window has not yet been destroyed!
      _pdlgTfwkUi->CloseWindow();
    delete _pdlgTfwkUi;
    _pdlgTfwkUi =NULL;
  }
}


void 
tfwkUiRunAllTest()
{
#ifdef TFWK_UI_DLL
  AFX_MANAGE_STATE( AfxGetStaticModuleState() );
#endif 
  tfwkUiShow();
  if ( _pdlgTfwkUi )
  {
    _pdlgTfwkUi->runAllTest();
  }
}


void 
tfwkUiRunSuite( const char *cszSuiteName )
{
#ifdef TFWK_UI_DLL
  AFX_MANAGE_STATE( AfxGetStaticModuleState() );
#endif 
  tfwkUiShow();
  if ( _pdlgTfwkUi )
  {
    _pdlgTfwkUi->runSuite( cszSuiteName );
  }
}
