// TfwkUiCfg.cpp: implementation of the TfwkUiCfg class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TfwkUi.h"
#include "TfwkUiCfg.h"
#include "TfwkUiCfgTestIt.h"
#include "Tfwk.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TfwkUiCfg::TfwkUiCfg() :
    _suiteRoot( NULL,
                _T( "Root" ) ),
    _bShowUnused( true )
{
  SetupUnitTestMap();
}


TfwkUiCfg::~TfwkUiCfg()
{
  POSITION it = _mapTestCfg.GetStartPosition();
  CString strName;
  TfwkUiTestCfg *pTest;

  while ( it )
  {
    _mapTestCfg.GetNextAssoc( it, strName, pTest );
    if ( pTest )
      delete pTest;
  }
}


void 
TfwkUiCfg::SetupUnitTestMap()
{
  const TfwkUnitTestInfo *pUnitTest = TfwkUnitTestInfo::firstUnitTest();

  // Adds all the test from the source.
  CString strTestName;
  CString strMethodName;

  for ( ; pUnitTest; pUnitTest = pUnitTest->nextUnitTest() )
  {
    strTestName = pUnitTest->nameTest();

    TfwkMethodInfoIt itMethod = pUnitTest->itMethod();
    for ( itMethod.begin(); !itMethod.isEnd(); itMethod.next() )
    {
      const TfwkUnitTestMethodInfo *pMethodInfo = itMethod.item();

      TfwkUiTestCfg *pTestCfg = new TfwkUiTestCfg( pMethodInfo, 1234 );
      pTestCfg->FullMethodName( strMethodName );    // class::method

      _mapTestCfg.SetAt( strMethodName, pTestCfg );
    }
  }
}


void 
TfwkUiCfg::ItTest( TfwkUiCfgTestIt &it, 
                   bool bShowUnused )
{
  it.Attach( *this, bShowUnused );
}


TfwkUiTestCfg *
TfwkUiCfg::FindTest( TfwkUiSourceId idSource,
                     const CString &strFullMethodName )
{
  TfwkUiTestCfg *pTest =NULL;
  if ( _mapTestCfg.Lookup( strFullMethodName, pTest ) )
    return pTest;
  return NULL;
}


TfwkUiSuite *
TfwkUiCfg::findSuite( const CString &strName )
{
  return findSuite( strName, &RootSuite() );
}


TfwkUiSuite *
TfwkUiCfg::findSuite( const CString &strName, TfwkUiSuite *pSuite )
{
  if ( !pSuite )
    return NULL;

  if ( pSuite->Name() == strName )
    return pSuite;

  TfwkUiSuite::SuiteIt itSuite = pSuite->ItSuite();
  for ( itSuite.begin(); !itSuite.isEnd(); itSuite.next() )
  {
    TfwkUiSuite *pSuiteFound = findSuite( strName, itSuite.item() );
    if ( pSuiteFound )
      return pSuiteFound;
  }

  return NULL;
}
