// TfwkUiCfgBuilderTree.h: interface for the TfwkUiCfgBuilderTree class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFWKUICFGBUILDERTREE_H__EDB173B7_41EF_11D3_BE2B_0040053AD648__INCLUDED_)
#define AFX_TFWKUICFGBUILDERTREE_H__EDB173B7_41EF_11D3_BE2B_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TfwkUiCfgBuilder.h"
class TfwkUiCfg;
#include "TfwkUiSuite.h"



class TfwkUiCfgBuilderTree : public TfwkUiCfgBuilder  
{
public:
	TfwkUiCfgBuilderTree();
	virtual ~TfwkUiCfgBuilderTree();

  /*!
   * Builds a suite.
   * @param strName [In] Name of the suite.
   */
  virtual void BuildSuite( const CString &strName );

  /*!
   * Builds a suite termination.
   * @return \c true if a suite was ended, otherwise returns \c false.
   */
  virtual bool BuildEndSuite();

  /*!
   * Builds a test.
   * @param strClass [In] Name of the class of the test.
   * @param strMethod [In] Name of the method of the test.
   */
  virtual void BuildTest( const CString &strClass,
                          const CString &strMethod );

  /*!
   * Tests if the current status is valid.
   * @return \c false if the status is not valid, otherwise returns \c true.
   */
  bool IsValid() const;

  /*!
   * Gets the suite tree.
   *
   * This operation can be done only once !
   * 
   * @return Pointer on the suite tree.
   */
  TfwkUiCfg *Config();

private:
  /*!
   * Current Suite depth.
   */
  int _nSuiteDepth;

  /*! 
   * Root of the suite tree.
   */
  TfwkUiCfg *_pConfig;

  /*!
   * Current depth suite.
   */
  TfwkUiSuite *_pSuite;
};

#endif // !defined(AFX_TFWKUICFGBUILDERTREE_H__EDB173B7_41EF_11D3_BE2B_0040053AD648__INCLUDED_)
