// EDragFileList.cpp: implementation of the CEDragFileList class.
//
//////////////////////////////////////////////////////////////////////

/* History:
- 18/01/98: - Get list of files: BuildList()
            - OpenDocuments()
            - GetList()
*/
             

#include "stdafx.h"
#include "EDragFileList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEDragFileList::CEDragFileList()
{

}

CEDragFileList::~CEDragFileList()
{

}

CEDragFileList::CEDragFileList(HDROP hDrop)
{
  BuildList( hDrop );
}

// Get the list of file from hDrop
// hDrop: file description given by message WM_DROPFILES & method OnDropFiles.
void CEDragFileList::BuildList(HDROP hDrop)
{
  UINT nbFiles = ::DragQueryFile( hDrop, 0xffffffff, NULL, 0 );
  ASSERT( nbFiles >= 0 );
  UINT no;

  m_files.SetSize( nbFiles );

  for ( no = 0; no < nbFiles; ++no )
  {
    CString& s = m_files[ no ];
    UINT stringLen = ::DragQueryFile( hDrop, no, NULL, 0 )+1;
    ::DragQueryFile( hDrop, no, s.GetBufferSetLength( stringLen ), stringLen );
    s.ReleaseBuffer();
  }

  for ( no = 0; no < nbFiles; ++no )
    TRACE( "File dropped: %s\n", (LPCSTR) m_files[ no ] );
}

// Run CWinApp::OpenDocumentFile( fileName ) for each file of the list.
void CEDragFileList::OpenDocuments( CWinApp *app ) const
{
  UINT nb = m_files.GetSize();
  UINT no;

  for (  no=0; no < nb; ++no )
    app->OpenDocumentFile( (LPCSTR) m_files[ no ] );
}
