// EwgProgressInfo.cpp: implementation of the EwgProgressInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ttr.h"
#include "EwgProgressInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EwgProgressInfo::EwgProgressInfo() :
    _bIsStarted( false ),
    _ulTickCountToStart( 100 ),
    _ulTickCountToUpdate( 1000 / 100),
    _nValueShift( 0 )
{

}


EwgProgressInfo &
EwgProgressInfo::setProgressRange( SL nMin, 
                                   SL nMax )
{
  _nMinValue = nMin;
  _nMaxValue = nMax;
  _nValue = nMin;
  _nValueShift =0;
  SL nRange = nMax -nMin;
  while ( nRange > 32767 )      // more than 16 bits ?
  {
    nRange >>= 1;
    ++_nValueShift;
  }
  return *this;
}


EwgProgressInfo &
EwgProgressInfo::setProgressValue( SL nValue )
{
  _nValue = (nValue - _nMinValue) >> _nValueShift;

  UL ulTickCount = GetTickCount();
  UL ulEllapsed = ulTickCount - _ulTickCountLast;
  if ( !isProgressStarted() )             // progress not started
  {
    if ( ulEllapsed > _ulTickCountToStart )    // start time has ellapsed !
    {
      _bIsStarted = true;
      _ulTickCountLast = ulTickCount;
      onProgressStart();
    }
  }
  else                // is already started
  {
    if ( ulEllapsed > _ulTickCountToUpdate )         // updates 70 times per second
    {
      _ulTickCountLast = ulTickCount;
      onProgress();
    }
  }
  return *this;
}
