// //////////////////////////////////////////////////////////////////////////
// Header file TtrFmtEltVisitor.h for class TtrFmtEltVisitor
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2000/09/16
// //////////////////////////////////////////////////////////////////////////
#ifndef TTRFMTELTVISITOR_H
#define TTRFMTELTVISITOR_H

class TtrFmtBlank;
class TtrFmtPara;



/*! \class TtrFmtEltVisitor
 * \brief This class implements a visitor for formatted text elements.
 */
class TtrFmtEltVisitor
{
public:
  /*! Destructor.
   */
  virtual ~TtrFmtEltVisitor() {}

  /*! Visits a blank block.
   * @param blank Blank block.
   */
  virtual void visitBlank( TtrFmtBlank &blank ) =0;

  /*! Visits a paragraph.
   * @param para Paragraph.
   */
  virtual void visitPara( TtrFmtPara &para ) =0;
};



// Inlines methods for TtrFmtEltVisitor:
// -------------------------------------



#endif  // TTRFMTELTVISITOR_H
