// //////////////////////////////////////////////////////////////////////////
// Header file TtrReformatterState.h for class TtrReformatterState
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2000/09/17
// //////////////////////////////////////////////////////////////////////////
#ifndef TTRREFORMATTERSTATE_H
#define TTRREFORMATTERSTATE_H


#include "TtrReformatterFsm.h"

// ////////////////////////////////////////////////////////////////////
// TtrReformatterState
// ////////////////////////////////////////////////////////////////////
class TtrReformatterState
{
public:
  TtrReformatterState() {}
  virtual ~TtrReformatterState() {}

  virtual void enterState( TtrReformatterFsm &fsm ) {}
  virtual void exitState( TtrReformatterFsm &fsm ) {}

  virtual void startBlank( TtrReformatterFsm &fsm ) {}
  virtual void startPara( TtrReformatterFsm &fsm ) {}
  virtual void continueBlock( TtrReformatterFsm &fsm ) {}
  virtual void endOfText( TtrReformatterFsm &fsm ) {}

protected:
  void changeState( TtrReformatterFsm &fsm,
                    TtrReformatterState &state );
};




// ////////////////////////////////////////////////////////////////////
// TtrReformatterStateInitial
// ////////////////////////////////////////////////////////////////////
class TtrReformatterStateInitial : public TtrReformatterState
{
public:
  TtrReformatterStateInitial() {}
  virtual ~TtrReformatterStateInitial() {}

  static TtrReformatterStateInitial &instance();

  virtual void startBlank( TtrReformatterFsm &fsm );
  virtual void startPara( TtrReformatterFsm &fsm );
  virtual void continueBlock( TtrReformatterFsm &fsm );
  virtual void endOfText( TtrReformatterFsm &fsm );
};




// ////////////////////////////////////////////////////////////////////
// TtrReformatterStateBlank
// ////////////////////////////////////////////////////////////////////
class TtrReformatterStateBlank : public TtrReformatterState
{
public:
  TtrReformatterStateBlank() {}
  virtual ~TtrReformatterStateBlank() {}

  static TtrReformatterStateBlank &instance();

  virtual void enterState( TtrReformatterFsm &fsm );
  virtual void exitState( TtrReformatterFsm &fsm );

  virtual void startBlank( TtrReformatterFsm &fsm );
  virtual void startPara( TtrReformatterFsm &fsm );
  virtual void continueBlock( TtrReformatterFsm &fsm );
  virtual void endOfText( TtrReformatterFsm &fsm );
};




// ////////////////////////////////////////////////////////////////////
// TtrReformatterStatePara
// ////////////////////////////////////////////////////////////////////
class TtrReformatterStatePara : public TtrReformatterState
{
public:
  TtrReformatterStatePara() {}
  virtual ~TtrReformatterStatePara() {}

  static TtrReformatterStatePara &instance();

  virtual void enterState( TtrReformatterFsm &fsm );
  virtual void exitState( TtrReformatterFsm &fsm );

  virtual void startBlank( TtrReformatterFsm &fsm );
  virtual void startPara( TtrReformatterFsm &fsm );
  virtual void continueBlock( TtrReformatterFsm &fsm );
  virtual void endOfText( TtrReformatterFsm &fsm );
};


// implemention of TtrReformatterState
// ////////////////////////////////////////////////////////////////////
inline void 
TtrReformatterState::changeState( TtrReformatterFsm &fsm,
                                             TtrReformatterState &state )
{
  fsm.changeState( state );
}



// Inlines methods for TtrReformatterState:
// ----------------------------------------



#endif  // TTRREFORMATTERSTATE_H
