// Generated by Together

#ifndef TTRTEXTRAW_H
#define TTRTEXTRAW_H

#include "TtrText.h"
#include "TtrTextLine.h"


class TtrTextRaw : public TtrText 
{
public:
  TtrTextRaw();
  virtual ~TtrTextRaw();

  /** Get the number of lines.
   * @return Number of lines.
   */
  virtual SL nbLine() const;

  /** Retreive a line of text.
   * @param nLineNo Line number (starting from 0).
   * @return Reference on the line.
   */
  virtual const TtrTextLine &line( SL nLineNo ) const;

  /** Retreive a line of text.
   * @param nLineNo Line number (starting from 0).
   * @return Reference on the line.
   */
  virtual TtrTextLine &line( SL nLineNo );

  /** Insert a line of text.
   * @param pLine Pointer on the line to insert.
   * @param nLineNo Insertion position (0 based). -1 to insert at the end of the text.
   */
  virtual void doInsertLine( TtrTextLine *pLine,
                             SL nLineNo =-1 );

  /** Delete a line of text.
   * @param nLineNo Number of the line to delete (starting from 0).
   */
  virtual void doDeleteLine( SL nLineNo );

  /** Delete all the text.
   */
  virtual void clear();

private:
/** @supplierCardinality 0..**/
  TtrTextLine * pTtrTextLine;

  TtrListTextLine _aLine;
};



// Inlines TtrTextRaw:
// -------------------

inline SL 
TtrTextRaw::nbLine() const
{
  return _aLine.count();
}


inline const TtrTextLine &
TtrTextRaw::line( SL nLineNo ) const
{
  if ( nLineNo >= 0  &&  nLineNo < nbLine() )
    return *_aLine.at( nLineNo );
  return TtrTextLine::getNullLine();
}


inline TtrTextLine &
TtrTextRaw::line( SL nLineNo )
{
  if ( nLineNo >= 0  &&  nLineNo < nbLine() )
    return *_aLine.at( nLineNo );
  return TtrTextLine::getNullLine();
}


#endif //TTRTEXTRAW_H

