// Generated by Together

#include "StdAfx.h"
#include "TtrTextWriterBuilderHtml.h"


        
/** Called at the beginning of the writing.*/
void 
TtrTextWriterBuilderHtml::buildStart( const TtrWriterSetting &setting )
{
  _state._nNewLine =0;
  _state._bIgnoreNewLine =true;
  string( "<HTML>" );
  nl();
}


/** Called at the end of the writing.*/
void 
TtrTextWriterBuilderHtml::buildEnd( const TtrWriterSetting &setting )
{
  _state._nNewLine =0;
  flush();
  string( "</HTML>" );
  nl();
}


void 
TtrTextWriterBuilderHtml::buildParagraph( const EString &strOriginalIndentation,
                                           const EString &strPara )
{
  flush();
  string( "&nbsp;" );    // add a small indent at the beginning of each paragraph
  string( "&nbsp;" );    
  string( "&nbsp;" );    
  string( "&nbsp;" );    
  string( escape( strPara ) );
  addNl();
}


/** Called to write one or more blank line.*/
void 
TtrTextWriterBuilderHtml::buildBlankBlock( SL nNbLine )
{
  addNl( nNbLine );
}

  
/** Called to write a line that has is a separator.*/
void 
TtrTextWriterBuilderHtml::buildSeparator( const EString &strSep )
{
  nl();
  _state._nNewLine = 0;
  string( "<P><CENTER>" );
  string( escape( strSep ) );
  string( "</CENTER><P>" );
  nl();

  _state._bIgnoreNewLine =true;
}

/** Called to write a paragraph that must be with the original 
* indentation (unchanged).*/
void 
TtrTextWriterBuilderHtml::buildOriginal( const EString &strOriginal )
{
  flush();

  SL nIdx;
  for ( nIdx =0; nIdx < strOriginal.length()  &&  
                 ::isspace( strOriginal[nIdx] ); ++nIdx )
  {
    string( "&nbsp;" );    // add a non-breakable space.
  }
  string( escape( strOriginal ) );
  addNl();
}


void 
TtrTextWriterBuilderHtml::br()
{
  stream() << "<BR>";
}


void 
TtrTextWriterBuilderHtml::p()
{
  stream() << "<P>";
}


void 
TtrTextWriterBuilderHtml::string( const EString &strText )
{
  stream().writeBlock( strText.datas(), strText.length() );
}


void 
TtrTextWriterBuilderHtml::nl()
{
  stream().writeLine();
}


void 
TtrTextWriterBuilderHtml::flush()
{
  EASSERT( _state._nNewLine >= 0 );

  _state._bIgnoreNewLine =false;

  if ( _state._nNewLine )
  {
    if ( --_state._nNewLine == 0)
    {
      br();
      nl();
    }
    else
    {
      while ( _state._nNewLine-- )
      {
        p();
        nl();
      }
      _state._nNewLine = 0;
    }
  }

  EASSERT( _state._nNewLine == 0 );
}


EString 
TtrTextWriterBuilderHtml::escape( const EString &strText )
{
  EString str;
  EString strChar;
  SL nIdx;
  for ( nIdx =0; nIdx < strText.length(); ++nIdx )
  {
    TCHAR tcChar = strText[ nIdx ];
    
    switch ( tcChar )
    {
    case '<': strChar = "&lt;"; break;
    case '>': strChar = "&gt;"; break;
    case '': strChar = "&eacute;"; break;
    case '': strChar = "&egrave;"; break;
    case '': strChar = "&agrave;"; break;
    case '': strChar = "&ugrave;"; break;
    default: strChar = tcChar; break;
    }

    str += strChar;
  }

  return str;
}


void 
TtrTextWriterBuilderHtml::addNl( SL nNewLine )
{
  if ( !_state._bIgnoreNewLine )
    _state._nNewLine += nNewLine;
}
