// Generated by Together

#ifndef TTRTEXTBUILDERRHTML_H
#define TTRTEXTBUILDERRHTML_H

#include "TtrTextWriterBuilder.h"
class TtrWriterSetting;

/** Builder to write text in the HTML format.*/
class TtrTextWriterBuilderHtml : public TtrTextWriterBuilder 
{
public:
/** Called to write a new paragraph.*/
  virtual void buildParagraph( const EString &strCurrentOrigIndent, 
                               const EString &strPara );
  
/** Called to write one or more blank line.*/
  virtual void buildBlankBlock( SL nNbLine );
      
/** Called to write a line that has is a separator.*/
  virtual void buildSeparator( const EString &strSep );
  
/** Called at the end of the writing.*/
  virtual void buildEnd( const TtrWriterSetting &setting );
            
/** Called at the beginning of the writing.*/
  virtual void buildStart( const TtrWriterSetting &setting );

  /** Called to write a paragraph that must be with the original 
  * indentation (unchanged).*/
  virtual void buildOriginal( const EString &strOriginal );

protected:
  /*! Write a line break.
   */
  void br();

  /*! Write a new paragraph.
   */
  void p();

  /*! Write a string.
   */
  void string( const EString &strText );

  /*! Write a new line.
   */
  void nl();

  /*! Flush state.
   */
  void flush();

  /*! Escape a text to an html string (replace '<' with "&lt;"...)
   */
  EString escape( const EString &strText );

  /*! Add some new lines.
   */
  void addNl( SL nNewLine =1 );

  struct State
  {
    SL _nNewLine;
    bool _bIgnoreNewLine;
  };

  State _state;
};

#endif //TTRTEXTBUILDERRHTML_H

