// TtrUtFormatter.h: interface for the TtrUtFormatter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRUTFORMATTER_H__86F2A8D5_5E71_4A0C_98BB_46A8478CAE99__INCLUDED_)
#define AFX_TTRUTFORMATTER_H__86F2A8D5_5E71_4A0C_98BB_46A8478CAE99__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <Tfwk.h>
#include "TtrGlobalSetting.h"
#include "TtrText.h"

class TtrText;

class TtrUtFormatter : public TfwkUnitTest  
{
public:
  TFWKDECL_UNITTEST( TtrUtFormatter );

	TtrUtFormatter();
	virtual ~TtrUtFormatter();

  void frmtIndentBlankLine();
  void frmtIndentIndentedLine();
  void frmtIndentPreviousLineIsBlankLine();
  void frmtIndentLineContainsDoubleDot();
  void frmtIndentLineBeginWithSquareBracket();
  void frmtIndentLineBeginWithRoundBracket();
  void frmtIndentSeparatorLine();
  void frmtEosMode();
  void frmtEosModeGrouping();
  void frmtEosModeGroupingSquareBracket();
  void frmtEosModeGroupingDoubleQuote();
  void frmtEosModeGroupingString();
  void frmtLeftMargin();
  void frmtRightMargin();

private:
  void resetMode();
  void analyseText();
  void setText( const EString &strText );
  TtrTextLine &line( int nLineNo );
  void checkPara( int nFirstLine, int nLastLine, bool bDump =false );
private:
  TtrGlobalSetting _mode;
  TtrText *_pText;
};

#endif // !defined(AFX_TTRUTFORMATTER_H__86F2A8D5_5E71_4A0C_98BB_46A8478CAE99__INCLUDED_)
