// TtrUtWriter.h: interface for the TtrUtWriter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRUTWRITTER_H__1470F83B_DBE8_409A_93D7_DA4A0D0276A0__INCLUDED_)
#define AFX_TTRUTWRITTER_H__1470F83B_DBE8_409A_93D7_DA4A0D0276A0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <Tfwk.h>
#include "TtrGlobalSetting.h"
class TtrText;
class EwgProgressInfo;

class TtrUtWriter : public TfwkUnitTest
{
public:
  TFWKDECL_UNITTEST( TtrUtWriter );

  TtrUtWriter();
	virtual ~TtrUtWriter();

  void writerTxtOriginal();
  void writerTxtIndentTab();
  void writerTxtIndent3Tab();
  void writerTxtIndentSpace();
  void writerTxtIndent3Space();
  void writerTxtIndentTabJumpOneLine();

private:
  void makePara( int nStartLine, int nCount );
  void makeOriginal( int nStartLine, int nCount );
  void setText( const EString &strText );
  void saveAndCheckTxt( const EString &strTestText );
  void reformattedText();
  void originalText();
private:
  TtrGlobalSetting _mode;
  TtrText *_pText;
  EwgProgressInfo *_pProgressInfo;
};

#endif // !defined(AFX_TTRUTWRITTER_H__1470F83B_DBE8_409A_93D7_DA4A0D0276A0__INCLUDED_)
